// 91. 解码方法
// 一条包含字母 A-Z 的消息通过以下映射进行了 编码 ：
// 'A' -> 1
// 'B' -> 2
// ...
// 'Z' -> 26
// 要 解码 已编码的消息，所有数字必须基于上述映射的方法，反向映射回字母（可能有多种方法）。例如，"11106" 可以映射为：
// "AAJF" ，将消息分组为 (1 1 10 6)
// "KJF" ，将消息分组为 (11 10 6)
// 注意，消息不能分组为  (1 11 06) ，因为 "06" 不能映射为 "F" ，这是由于 "6" 和 "06" 在映射中并不等价。
// 给你一个只含数字的 非空 字符串 s ，请计算并返回 解码 方法的 总数 。
// 题目数据保证答案肯定是一个 32 位 的整数。
//https://leetcode-cn.com/problems/decode-ways

//Rust实现
impl Solution {
    pub fn num_decodings(s: String) -> i32 {
       let mut res = vec![1, 1];
       let mut reslen = 2;
       let mut pre = '0';
       for ch in s.chars() {
           let mut tmp = 0;
           if (pre == '1' || (pre == '2' && ch <= '6')) {
               tmp += res[reslen - 2];
           }
           if (ch != '0') {
               tmp += res[reslen - 1];
           }
           res.push(tmp);
           reslen += 1;
           pre = ch;
       }
       res[reslen - 1] 
    }
}

//C++实现
// class Solution {
// public:
//    int numDecodings(string s) {
//        vector<int> res = {1, 1};
//        int reslen = 2;
//        char pre = '0';
//        for (auto & ch : s) {
//            int tmp = 0;
//            if (pre == '1' || (pre == '2' && ch <= '6')) tmp += res[reslen - 2];
//            if (ch != '0') tmp += res[reslen - 1];
//            res.push_back(tmp);
//            reslen++;
//            pre = ch;
//        }
//        return res.back();
//    }
// };