# Notes

- [Notes](#notes)
  - [堆和栈](#堆和栈)
  - [移动、clone、copy](#移动、clone、copy)
  - [函数与作用域](#函数与作用域)

  - [所有权](#所有权)
    - [引用](#引用)
    - [借用](#借用)
  - [slice](#slice)
## 堆和栈
- 编译的时候数据的类型大小是固定的，就是分配在栈上的
- 编译的时候数据类型大小不固定，就是分配在堆上的
## 移动、clone、copy
```
//move
let s1 = String::from("Leedia");//堆上
let s2 = s1;
println!("s2= {}"，s2) ;
//println!("s1= {}", s1); //move to s2, s1 invalid

//clone
let s3 = s2.clone();
println!("s3= {}",s3) ;
println!("s2= {}",s2) ;

//copy trait
let a=1;
let b=a;
println!("a = {}, b = {}", a, b);
//常用的具有copy trait有
//所有的整型
//浮点型
//布尔值
//字符类型char
//元组

```
## 函数与作用域
- 分配在堆上的变量在传入函数体之后会被drop;如需使用，应传回
- 分配在栈上的变量在传入函数体之后不会被drop;
## 所有权
### 引用
1、在任意给定时间，有了可变引用之后不能再有不可变引用
2、引用必须有效
```
//引用:用法&,
//让我们创建一个指向值的应用，但是并不拥有它，因为不拥有这个值，所以，当引用离开其值指向的作用域后也不
会被丢弃
fn calcute Length(s: &String) ->usize {
    s.Len( )
}
fn main() {
    Let s1 = String: :from("hello");
    let Len = calcute_ Length(&s1) ;
    println!("s1 = {}", s1) ;
    println!("len = {}"，Len) ;
}
```
### 借用
可变引用，在函数中可以push_str等,传参时传&mut

## slice
- 1、字符串slice是String中一部分值的引用 
```
lets = String: : from( "hello world" );
let h = &s [0..5];
let h = &s [0..=4];
let h = &s [ ..=4];
let h = &s [..5];
```
- 2、字面值就是slice
- 3、其它类型slice
